import java.io.File;
import java.util.Calendar;
import java.util.Locale;

import com.cs.util.LicenseUtil;
import com.spire.xls.CellRange;
import com.spire.xls.CellStyle;
import com.spire.xls.FileFormat;
import com.spire.xls.PageSetup;
import com.spire.xls.Workbook;
import com.spire.xls.Worksheet;

public class SampleSingle {
	
	public static void main(String[] args) {
		convertExcelToPdf();
	}
    
    public static void convertExcelToPdf() {
        
        File file = new File("E:\\Portfolio Valuation Model - Apera Dec2.xlsm");
        String outputFileName = "E:\\Portfolio Valuation Model - Apera Dec2.pdf";
        
        LicenseUtil.applyApiLicense();
        
        System.out.println(Calendar.getInstance().getTime()+":::::::::::: Start processing file ::: "+file.getName());

        Workbook workbook = new Workbook();
        workbook.loadFromFile(file.getPath());
        workbook.getConverterSetting().setSheetFitToWidth(true);
        workbook.getConverterSetting().isReCalculateOnConvert(false);
        
        for (int i = 0; i < workbook.getWorksheets().size(); i++) {
        	
            Worksheet worksheet = workbook.getWorksheets().get(i);
            
//            if (worksheet.getPivotTables().getCount() == 0) {
//                worksheet.CalculateAllValue();
//            }

            for (int col = worksheet.getFirstColumn(); col <= worksheet.getLastColumn(); col++){
              CellStyle style = worksheet.getDefaultColumnStyle(col);
              style.setShrinkToFit(true);
              style.setWrapText(false);
            }
            
            Boolean isRowMerged = false;
        	Boolean isColMerged = false;

            CellRange[] rows = worksheet.getRows();
            CellRange[] columns = worksheet.getColumns();
            
            for (int r = 0; r < rows.length; r++) {
                if (rows[r].hasMerged()) {
                	rows[r].autoFitColumns();
                	isRowMerged = true;
                    break;
                }
            }
            
            for (int r = 0; r < columns.length; r++) {
                if (columns[r].hasMerged()) {
                	rows[r].autoFitRows();
                	isColMerged = true;
                    break;
                }
            }
            
            if(!isRowMerged && !isColMerged) {
            	worksheet.getAllocatedRange().autoFitColumns();
                worksheet.getAllocatedRange().autoFitRows();
            }

            PageSetup pageSetup = worksheet.getPageSetup();
            pageSetup.setPrintArea(null);
        }
        workbook.saveToFile(outputFileName, FileFormat.PDF);
    	workbook.dispose();
    	System.out.println(Calendar.getInstance().getTime()+"------------ Processed file ::: "+file.getName());
    }
}
